# coding: utf-8

import re
import six



from huaweicloudsdkcore.utils.http_utils import sanitize_for_serialization


class ListSimPricePlansRequest:


    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """

    sensitive_list = []

    openapi_types = {
        'sim_card_id': 'int',
        'sim_price_plan_id': 'int',
        'real_time': 'bool',
        'limit': 'int',
        'offset': 'int'
    }

    attribute_map = {
        'sim_card_id': 'sim_card_id',
        'sim_price_plan_id': 'sim_price_plan_id',
        'real_time': 'real_time',
        'limit': 'limit',
        'offset': 'offset'
    }

    def __init__(self, sim_card_id=None, sim_price_plan_id=None, real_time=None, limit=None, offset=None):
        """ListSimPricePlansRequest - a model defined in huaweicloud sdk"""
        
        

        self._sim_card_id = None
        self._sim_price_plan_id = None
        self._real_time = None
        self._limit = None
        self._offset = None
        self.discriminator = None

        self.sim_card_id = sim_card_id
        if sim_price_plan_id is not None:
            self.sim_price_plan_id = sim_price_plan_id
        if real_time is not None:
            self.real_time = real_time
        if limit is not None:
            self.limit = limit
        if offset is not None:
            self.offset = offset

    @property
    def sim_card_id(self):
        """Gets the sim_card_id of this ListSimPricePlansRequest.

        SIM卡标识，可通过[查询SIM卡列表接口](https://support.huaweicloud.com/api-ocgsl/gsl_07_0008.html)获取

        :return: The sim_card_id of this ListSimPricePlansRequest.
        :rtype: int
        """
        return self._sim_card_id

    @sim_card_id.setter
    def sim_card_id(self, sim_card_id):
        """Sets the sim_card_id of this ListSimPricePlansRequest.

        SIM卡标识，可通过[查询SIM卡列表接口](https://support.huaweicloud.com/api-ocgsl/gsl_07_0008.html)获取

        :param sim_card_id: The sim_card_id of this ListSimPricePlansRequest.
        :type: int
        """
        self._sim_card_id = sim_card_id

    @property
    def sim_price_plan_id(self):
        """Gets the sim_price_plan_id of this ListSimPricePlansRequest.

        套餐实例ID

        :return: The sim_price_plan_id of this ListSimPricePlansRequest.
        :rtype: int
        """
        return self._sim_price_plan_id

    @sim_price_plan_id.setter
    def sim_price_plan_id(self, sim_price_plan_id):
        """Sets the sim_price_plan_id of this ListSimPricePlansRequest.

        套餐实例ID

        :param sim_price_plan_id: The sim_price_plan_id of this ListSimPricePlansRequest.
        :type: int
        """
        self._sim_price_plan_id = sim_price_plan_id

    @property
    def real_time(self):
        """Gets the real_time of this ListSimPricePlansRequest.

        是否查实时流量

        :return: The real_time of this ListSimPricePlansRequest.
        :rtype: bool
        """
        return self._real_time

    @real_time.setter
    def real_time(self, real_time):
        """Sets the real_time of this ListSimPricePlansRequest.

        是否查实时流量

        :param real_time: The real_time of this ListSimPricePlansRequest.
        :type: bool
        """
        self._real_time = real_time

    @property
    def limit(self):
        """Gets the limit of this ListSimPricePlansRequest.

        分页查询时每页显示的记录数，默认值为10，取值范围为10-500的整数

        :return: The limit of this ListSimPricePlansRequest.
        :rtype: int
        """
        return self._limit

    @limit.setter
    def limit(self, limit):
        """Sets the limit of this ListSimPricePlansRequest.

        分页查询时每页显示的记录数，默认值为10，取值范围为10-500的整数

        :param limit: The limit of this ListSimPricePlansRequest.
        :type: int
        """
        self._limit = limit

    @property
    def offset(self):
        """Gets the offset of this ListSimPricePlansRequest.

        分页查询时的页码数，默认值为1，取值范围为1-1000000的整数

        :return: The offset of this ListSimPricePlansRequest.
        :rtype: int
        """
        return self._offset

    @offset.setter
    def offset(self, offset):
        """Sets the offset of this ListSimPricePlansRequest.

        分页查询时的页码数，默认值为1，取值范围为1-1000000的整数

        :param offset: The offset of this ListSimPricePlansRequest.
        :type: int
        """
        self._offset = offset

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                if attr in self.sensitive_list:
                    result[attr] = "****"
                else:
                    result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        import simplejson as json
        if six.PY2:
            import sys
            reload(sys)
            sys.setdefaultencoding("utf-8")
        return json.dumps(sanitize_for_serialization(self), ensure_ascii=False)

    def __repr__(self):
        """For `print`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ListSimPricePlansRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
